<template>
  <div class="detail" :class="width > 750 && 'bg-img'">
    <div class="row w-75 mx-auto pt-5">
      <div class="col-12">
        <div class="d-flex justify-content-around align-items-center">
          <div class="d-flex gap-2">
            <img
              class="img-thumbnail rounded"
              :src="currentPhoto?.user.profile_image.small"
              alt="" />

            <div class="row" :class="width > 750 && 'text-white'">
              <div class="col-12">
                {{ currentPhoto?.user.name }}
              </div>
              <div class="col-12">@{{ currentPhoto?.user.username }}</div>
            </div>
          </div>
          <div class="d-flex gap-2 align-items-center justify-content-center">
            <button class="btn btn-light" @click="handleLikeClick">
              <i
                v-if="
                  likedPhotos.some((photo) => photo.id === currentPhoto?.id)
                "
                class="bi bi-heart-fill text-warning"></i>
              <i v-else class="bi bi-heart"></i>
            </button>
            <button
              class="btn btn-warning"
              @click="downloadPhoto(currentPhoto?.id || '')">
              <i class="bi bi-download"></i>
              <span class="d-none d-md-inline">Download</span>
            </button>
          </div>
        </div>
      </div>
      <div
        v-if="width > 750"
        class="mt-3 mb-5 col-12 d-flex justify-content-center align-items-center">
        <img class="rounded" :src="currentPhoto?.urls.regular" alt="" />
      </div>
      <div
        v-else
        class="mt-3 mb-5 col-12 d-flex justify-content-center align-items-center">
        <img class="rounded" :src="currentPhoto?.urls.thumb" alt="" />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import HeartIcon from "@/icons/HeartIcon.vue";
import { usePhotosStore } from "@/stores/usePhotosStore";
import { defineComponent, onMounted, onUnmounted, ref } from "vue";

export default defineComponent({
  name: "DetailView",
  components: { HeartIcon },

  setup() {
    const {
      currentPhoto,
      likedPhotos,
      addLikedPhoto,
      removePhotoFromLiked,
      downloadPhoto,
      likePhoto,
      unlikePhoto,
    } = usePhotosStore();

    const width = ref(window.innerWidth);

    onMounted(() => {
      window.addEventListener("resize", () => {
        width.value = window.innerWidth;
      });
    });

    onUnmounted(() => {
      window.removeEventListener("resize", () => {
        width.value = window.innerWidth;
      });
    });

    const handleLikeClick = () => {
      // if (currentPhoto?.liked_by_user) {
      //   unlikePhoto(currentPhoto.id);
      // } else {
      //   likePhoto(currentPhoto?.id || "");
      // }
      if (likedPhotos.some((photo) => photo.id === currentPhoto?.id)) {
        removePhotoFromLiked(currentPhoto);
      } else {
        addLikedPhoto(currentPhoto);
      }
    };

    return {
      width,
      currentPhoto,
      likedPhotos,
      downloadPhoto,
      likePhoto,
      unlikePhoto,
      handleLikeClick,
    };
  },
});
</script>

<style scoped>
.detail {
  width: 100%;
}
.bg-img {
  background-image: url("../assets/detailBackground.png");
  background-size: cover;
  background-position: center;
  background-repeat: no-repeat;
  height: 400px;
}
.img img {
  width: 80%;
  height: 400px;
}
</style>
